                             
' /////////////////////////////////////////////////////////////////////////////
' Donkey Kong Remake
' AUTHOR: Steve Waddicor
'//////////////////////////////////////////////////////////////////////////////

OBJ

  tv    : "sw_dk_tv_drv_021.spin"
  gfx   : "sw_dkong_gfx_005.spin"
  rend  : "sw_dk_gfx_renderer_012.spin"

CON
    _clkmode = xtal1 + pll8x
    _xinfreq = 10_000_000 + 0000
    _stack = 200
    '1 cog for game logic (this one)
    '1 cog for TV driver
    '1 cog for sound
    '=5 cogs for rendering
    cogs = 5

CON
    SPRITE_FLAGS                =3
    SPRITE_TILE                 =2
    SPRITE_XPOS                 =1
    SPRITE_YPOS                 =0
    SPRITE_FLAGS_AND_TILE_WORD  =1 
    SPRITE_INVISIBLE            =%100
    SPRITE_FLIPPED              =%010
    SPRITE_MIRRORED             =%001
    
CON
    NUMBER_OF_BARRELS           = 10
    NUMBER_OF_LADDERS           = 2
    NUMBER_OF_SPRINGS           = 2
    NUMBER_OF_PIES              = 5

CON
    BLANK_MAP   = 0
    LEVEL1_MAP  = 1
    LEVEL2_MAP  = 2
    LEVEL3_MAP  = 3
    LEVEL4_MAP  = 4
    
CON
    #0
    'states where user input accepted
    MARIO_FACING_LEFT 
    MARIO_FACING_RIGHT
    MARIO_WALK_LEFT   
    MARIO_WALK_RIGHT  
    MARIO_HAMMER_LEFT 
    MARIO_HAMMER_RIGHT
    MARIO_CLIMB_UP    
    MARIO_CLIMB_DOWN  
    'no user input accepted
    MARIO_JUMP_LEFT           
    MARIO_JUMP_RIGHT          
    MARIO_JUMP_UP_FACING_LEFT  
    MARIO_JUMP_UP_FACING_RIGHT
    MARIO_LANDING_LEFT        
    MARIO_LANDING_RIGHT       

CON
    #0
    MARIO_NOT_ON_LIFT
    MARIO_LIFT_UP
    MARIO_LIFT_DOWN

CON
    GAME_HOW_HIGH_INIT          = 0
    GAME_INIT_LEVEL_1           = 1
    GAME_INIT_LEVEL_2           = 2
    GAME_INIT_LEVEL_3           = 3
    GAME_INIT_LEVEL_4           = 4
    GAME_HOW_HIGH               = 5
    GAME_LEVEL_1                = 6
    GAME_LEVEL_2                = 7
    GAME_LEVEL_3                = 8
    GAME_LEVEL_4                = 9

CON

    KONG_LEVEL_START_POSE_INIT  = 0
    KONG_LEVEL_START_POSE       = 1
    ' Barrel rolling states i.e. Level 1
    KONG_BR_LEFT                = 2
    KONG_BR_CENTER_1            = 3
    KONG_BR_RIGHT               = 4
    KONG_BR_CENTER_2            = 5
    KONG_BR_GROWL               = 6
    KONG_BR_LEFT_INIT           = 7
    KONG_BR_CENTER_1_INIT       = 8
    KONG_BR_RIGHT_INIT          = 9
    KONG_BR_CENTER_2_INIT       = 10
    KONG_BR_GROWL_INIT          = 11
    ' Normal states i.e. Levels 2-4
    KONG_NORMAL_INIT            = 12
    KONG_NORMAL                 = 13    

CON
    BARREL_STILL                = 0
    BARREL_ROLLING_RIGHT        = 1
    BARREL_ROLLING_LEFT         = 2
    BARREL_FALLING_RIGHT        = 3
    BARREL_FALLING_LEFT         = 4
    BARREL_BOUNCING_RIGHT       = 5
    BARREL_BOUNCING_LEFT        = 6
    BARREL_ON_LADDER_RIGHT      = 7
    BARREL_ON_LADDER_LEFT       = 8
    BARREL_FALLING_DOWN         = 9
    BARREL_FALLING_ACROSS       = 10
    FIREBALL_JUMP_RIGHT_INIT    = 11
    FIREBALL_JUMP_RIGHT         = 12
    FIREBALL_BOUNCE_LEFT_INIT   = 13
    FIREBALL_BOUNCE_RIGHT_INIT  = 14
    FIREBALL_BOUNCE_LEFT        = 15
    FIREBALL_BOUNCE_RIGHT       = 16
    FIREBALL_MOVE_RIGHT         = 17
    FIREBALL_UP_LADDER          = 18
    FIREBALL_DOWN_LADDER        = 19
    FIREBALL_WAITING            = 20

CON
    DRUM_UNLIT                  = 0
    DRUM_LIT                    = 1
    DRUM_FLARING                = 2
    DRUM_LIT_INIT               = 3
    DRUM_FLARING_INIT           = 4

CON
    PAULINE_STILL_INIT          = 0
    PAULINE_STILL               = 1
    PAULINE_SCREAM_INIT         = 2
    PAULINE_SCREAM              = 3

CON
    LADDER_UP                   = 0
    LADDER_GOING_DOWN           = 1
    LADDER_DOWN                 = 2
    LADDER_GOING_UP             = 3

CON
    #0
    CONVEYOR_RIGHT
    CONVEYOR_LEFT

VAR
    ' Renderer parameter block
    ' Initializing data is in the DAT block at the end of this file.
    ' This is copied in to this variable space with a longmove
    ' so it can be altered easily (without remembering to use @ all the time).
    ' Each renderer then copies these values to it's own cog_memory cache
    ' when it's got a little spare time, several times per frame
    ' so these values can be altered on the fly.                                                       
    long    rend_cog_number        'each cog gets a different number, starting with zero     write-only
    long    rend_scanline_req_adr  'a pointer to the request to put a line in the scan buffer   write-only
    long    rend_map               'pointer to screen (bytes)                                write-only
    long    rend_tile_table_ptr    'pointer to tile definitions (words)                      write-only
    long    rend_tile_palette_ptr
    long    rend_sprite_table_ptr  'pointer to tile definitions (longs)                      write-only
    long    rend_hotspot_table_ptr  
    long    rend_sprite_palette_ptr 'pointer to colors (longs)                               write-only               
    long    rend_ht                'horizontal tiles                                         write-only
    long    rend_vt                'vertical tiles                                           write-only
    long    rend_scanline_buffer_adr 'hub memory where renderer puts scanline when requested write-only
    long    rend_cog_count         'total number of cogs                                     write-only
    long    rend_debug_map_ptr
    long    rend_sprites[34]       '%_____ifm_nnnnnnnn_xxxxxxxx_yyyyyyyy    (invisible, flipped, mirrored)
    'End of redderer parameter block

VAR
    ' TV parameter block
    long    tv_scanline_request
    long    tv_scanline_buffer
    long    tv_status
    ' End of TV parameter block  

VAR
    long  startkey
    long  debug
    word  debug_map[32*28]


VAR
    long    gp
    long    mario_state
    long    mario_state_count
    long    mario_lift_state
    long    game_state
    long    game_state_count
    long    game_level
    long    kong_state
    long    kong_state_count
    long    kong_pose_source
    long    kong_barrel_releases
    long    kong_holding_barrel
    long    kong_real_x
    long    kong_real_y
    long    kong_conveyor_state
    long    kong_conveyor_state_count
    long    middle_left_conveyor_state
    long    middle_right_conveyor_state
    long    bottom_conveyor_state
    long    conveyor_state_count
    long    pie_state_count
    long    barrel_state[NUMBER_OF_BARRELS]
    long    barrel_state_count[NUMBER_OF_BARRELS]
    long    barrel_anim[NUMBER_OF_BARRELS]
    long    fireball_real_y[NUMBER_OF_BARRELS]
    long    drum_state
    long    drum_state_count
    long    drum_flicker_count
    long    pauline_state
    long    pauline_state_count
    long    ladder_state[NUMBER_OF_LADDERS]
    long    ladder_state_count[NUMBER_OF_LADDERS]
    long    lift_state_count
    long    spring_state_count[2]
    long    spring_real_x[2]
    long    frame
    long    rnd

CON
    NUMBER_OF_SPRITES           = 34

' Level 1 = Barrels
' Level 2 = Springs
' Level 3 = Conveyors
' Level 4 = Rivets

'    Level 1           Level 2           Level 3           Level 4                  
'  0 Kong              Kong              Kong              Kong                     
'  1 Kong              Kong              Kong              Kong                     
'  2 Kong              Kong              Kong              Kong                     
'  3 Kong              Kong              Kong              Kong                     
'  4 Kong              Kong              Kong              Kong                     
'  5 Kong              Kong              Kong              Kong                     
'  6 Kong                                Ladder                                     
'  7 Kong                                Ladder                                     
'  8 Mario             Mario             Mario             Mario                    
'  9 Barrel/Fireball   Barrel/Fireball   Barrel/Fireball   Barrel/Fireball          
'  0 Barrel/Fireball   Barrel/Fireball   Barrel/Fireball   Barrel/Fireball          
' 11 Barrel/Fireball   Spring            Barrel/Fireball   Barrel/Fireball          
' 12 Barrel/Fireball   Spring            Barrel/Fireball   Barrel/Fireball          
' 13 Barrel/Fireball   Lift              Barrel/Fireball   Barrel/Fireball          
' 14 Barrel/Fireball   Lift              Pie                                        
' 15 Barrel/Fireball   Lift              Pie                                        
' 16 Barrel/Fireball   Lift              Pie                                        
' 17 Barrel/Fireball   Lift              Pie                                        
' 18 Barrel/Fireball   Lift              Pie                                        
' 19 Fixed-Barrel      Winch             Motor                                      
' 20 Fixed-Barrel      Winch             Motor                                      
' 21 Fixed-Barrel      Winch             Motor                                      
' 22 Fixed-Barrel      Winch             Motor                                      
' 23                                     Motor                                                        
' 24                                     Motor                                                        
' 25                   Umbrella          Umbrella          Umbrella                 
' 26                   Hat               Hat               Hat                      
' 27                   Handbag           Handbag           Handbag                  
' 28 Oil Drum                            Oil Drum                                   
' 29 Oil Drum Flame                      Oil Drum Flame                             
' 30 Hammer            Hammer            Hammer            Hammer                     
' 31 Hammer            Hammer            Hammer            Hammer                     
' 32 Pauline           Pauline           Pauline           Pauline                    
' 33 Pauline           Pauline           Pauline           Pauline                    
  
    'sprite indexes 
    KONG_SPRITES                = 0                        
    LADDER_SPRITES              = 6                                      
    MARIO_SPRITE                = 8                
    MOVING_BARREL_SPRITES       = 9
    SPRING_SPRITES              = 11
    LIFT_SPRITES                = 13
    PIE_SPRITES                 = 14                    
    FIXED_BARREL_SPRITES        = 19
    WINCH_SPRITES               = 19
    MOTOR_SPRITES               = 19
    COLLECTABLE_SPRITES         = 25
    OIL_DRUM_SPRITE             = 28
    OIL_DRUM_FLAME_SPRITE       = 29                    
    HAMMER_SPRITES              = 30            
    PAULINE_SPRITES             = 31                       


PUB Main | i, time, game_counter, total_time, avg_time
    'Start renderers
'    long[@kong_center_barrel_template][0]:=$00_10_80_80
    rend_tile_table_ptr := gfx.tile_adr
    rend_sprite_table_ptr := gfx.sprite_adr
    rend_hotspot_table_ptr := gfx.sprite_hotspot_adr
    rend_sprite_palette_ptr := gfx.sprite_palette_adr
    rend_tile_palette_ptr := gfx.tile_palette_adr
    SelectMap(BLANK_MAP)
    rend_ht := 32
    rend_vt := 28
    rend_scanline_buffer_adr := @hub_scanline_buffer
    rend_scanline_req_adr := @scanline_req
    rend_cog_count := cogs
    repeat i from 0 to constant(NUMBER_OF_SPRITES-1)
        rend_sprites[i] := $04_00_00_00                 'make them all invisible by default


    rend_debug_map_ptr := 0
    repeat i from 0 to constant(cogs-1)
        rend_cog_number := i
        rend.start(@rend_cog_number)
        'Wait to allow this cog to get the cog number param from the block before changing it.
        repeat 1000
     
    tv_scanline_request := @scanline_req                
    tv_scanline_buffer := @hub_scanline_buffer          
'    tv_status_ptr := @tv_status          
    tv.start(@tv_scanline_request)
    
    DebugInit(@debug_map)
    rend_debug_map_ptr:=0
    

    game_state := GAME_HOW_HIGH_INIT
    game_counter := 0
    game_level := 1
    time:=CNT
    rnd:=$439d82f0

    'Main Game Loop
    repeat
        'TV will let up know when there is a vsync
        tv_status := 0
'        outa[1]:=1
        
        gp := NES_Read_Gamepad


        case game_state
            GAME_HOW_HIGH_INIT:
                SpriteClear
                SelectMap(BLANK_MAP)
                PrintString(5,26,string("HOW HIGH CAN YOU GET ?"),4)
                repeat i from 0 to game_level//4
                    PrintKong(13,21-i*4)
                    PrintKongHeight(8,24-i*4,i)
                game_state := GAME_HOW_HIGH
                game_state_count := 160
            GAME_HOW_HIGH:
                game_state_count--
                if game_state_count == 0
                    game_state := GAME_INIT_LEVEL_1 + game_level//4   
            GAME_INIT_LEVEL_1:
                InitLevelCommon
                InitLevel1
            GAME_INIT_LEVEL_2:
                InitLevelCommon
                InitLevel2
            GAME_INIT_LEVEL_3:
                InitLevelCommon
                InitLevel3
            GAME_INIT_LEVEL_4:
                InitLevelCommon
                InitLevel4
            GAME_LEVEL_1:    
                if !(rend_sprites.byte[SPRITE_FLAGS]&SPRITE_INVISIBLE)  'NEEDS FIXING!!!!!!!!!!!!!!!!!!!!!
                    MarioLogic
                KongLogic
                BarrelLogic
                DrumLogic
                PaulineLogic
            GAME_LEVEL_2:    
                LiftLogic
                if !(rend_sprites.byte[SPRITE_FLAGS]&SPRITE_INVISIBLE)
                    MarioLogic
                KongLogic
                BarrelLogic
                SpringLogic
                PaulineLogic
            GAME_LEVEL_3:    
                if !(rend_sprites.byte[SPRITE_FLAGS]&SPRITE_INVISIBLE)
                    MarioLogic
                KongLogic
                LadderLogic
                ConveyorLogic
                PaulineLogic
            GAME_LEVEL_4:    
                if !(rend_sprites.byte[SPRITE_FLAGS]&SPRITE_INVISIBLE)
                    MarioLogic
                KongLogic
                PaulineLogic
                                 
        if gp & %00010000
            if startkey==0
                startkey:=1
                !debug
                if debug
                    rend_debug_map_ptr:=@debug_map
                else
                    rend_debug_map_ptr:=0
        else
            startkey:=0
        DebugInit(@debug_map)

        total_time:=CNT-time
        'debugdec(@timetext,((cnt-time)/game_counter++))
        'debughex(@timetext,$89abcdef)
        'repeat 10000
        repeat until tv_status>0
        
PRI SpriteClear | i
    repeat i from 0 to NUMBER_OF_SPRITES
        rend_sprites[i]:= $04_00_10_00
    repeat i from 0 to constant(NUMBER_OF_BARRELS-1)
        barrel_state[i] := BARREL_STILL
    
PRI InitLevelCommon
    SpriteClear
    pauline_state := PAULINE_SCREAM_INIT
    frame := SPRITE_INVISIBLE<<8
    kong_state := KONG_LEVEL_START_POSE_INIT

PRI InitLevel1 | i
    ' Barrels & Slopes
    SelectMap(LEVEL1_MAP)
    kong_real_x := $3c
    kong_real_y := $33
    rend_sprites[MARIO_SPRITE]           := $04_00_3c_d7
    rend_sprites[FIXED_BARREL_SPRITES  ] := $00_17_14_23
    rend_sprites[FIXED_BARREL_SPRITES+1] := $00_17_14_32
    rend_sprites[FIXED_BARREL_SPRITES+2] := $00_17_1e_23
    rend_sprites[FIXED_BARREL_SPRITES+3] := $00_17_1e_32
    rend_sprites[HAMMER_SPRITES]         := $00_1b_25_4b
    rend_sprites[HAMMER_SPRITES+1]       := $00_1b_bc_a7
    rend_sprites[OIL_DRUM_SPRITE]        := $00_42_28_d8
    repeat i from 0 to constant(NUMBER_OF_BARRELS-1)
        barrel_state[i] := BARREL_STILL
    game_state := GAME_LEVEL_1
    
PRI InitLevel2 | i
    ' Springs
    SelectMap(LEVEL2_MAP)
    kong_real_x := $3c
    kong_real_y := $37
    rend_sprites[MARIO_SPRITE]           := $04_00_10_c7
    rend_sprites[LIFT_SPRITES  ]         := $00_3F_38_64
    rend_sprites[LIFT_SPRITES+1]         := $00_3F_38_98 '+$34
    rend_sprites[LIFT_SPRITES+2]         := $00_3F_38_cc
    rend_sprites[LIFT_SPRITES+3]         := $00_3F_78_48
    rend_sprites[LIFT_SPRITES+4]         := $00_3F_78_7c
    rend_sprites[LIFT_SPRITES+5]         := $00_3F_78_b0
    rend_sprites[WINCH_SPRITES  ]        := $00_40_38_38
    rend_sprites[WINCH_SPRITES+1]        := $02_40_38_cf
    rend_sprites[WINCH_SPRITES+2]        := $00_40_78_38
    rend_sprites[WINCH_SPRITES+3]        := $02_40_78_cf
    rend_sprites[COLLECTABLE_SPRITES  ]  := $00_51_1c_67 'umbrella
    rend_sprites[COLLECTABLE_SPRITES+1]  := $00_4f_5c_af 'hat
    rend_sprites[COLLECTABLE_SPRITES+2]  := $00_50_e4_47 'handbag   
    rend_sprites[MOVING_BARREL_SPRITES  ]:= $00_39_58_68
    rend_sprites[MOVING_BARREL_SPRITES+1]:= $00_39_e4_48
    fireball_real_y[0]                   := $68
    fireball_real_y[1]                   := $48    
    barrel_state[0]                      := FIREBALL_BOUNCE_LEFT_INIT
    barrel_state[1]                      := FIREBALL_BOUNCE_RIGHT_INIT
    rend_sprites[SPRING_SPRITES]         := $00_37_78_37
    rend_sprites[SPRING_SPRITES+1]       := $00_37_88_37
    spring_state_count[0]                :=0
    spring_state_count[1]                :=-100
    spring_real_x[0]                     :=0
    spring_real_x[1]                     :=0
    
    game_state := GAME_LEVEL_2

PRI InitLevel3 | i
    ' Conveyors
    SelectMap(LEVEL3_MAP)
    kong_real_x := $40
    kong_real_y := $37
    rend_sprites[MARIO_SPRITE]           := $04_00_3c_d7
    rend_sprites[LADDER_SPRITES  ]       := $00_41_24_4f
    rend_sprites[LADDER_SPRITES+1]       := $00_41_dc_4f
    ladder_state[0] := LADDER_UP
    ladder_state[1] := LADDER_UP
    rnd := ?rnd
    ladder_state_count[0] := rnd&$ff
    rnd := ?rnd
    ladder_state_count[1] := rnd&$ff
    rend_sprites[MOTOR_SPRITES  ]        := $00_47_10_38
    rend_sprites[MOTOR_SPRITES+1]        := $01_47_e0_38
    rend_sprites[MOTOR_SPRITES+2]        := $01_47_6c_60
    rend_sprites[MOTOR_SPRITES+3]        := $00_47_84_60
    rend_sprites[MOTOR_SPRITES+4]        := $00_47_10_b0
    rend_sprites[MOTOR_SPRITES+5]        := $01_47_e0_b0
    rend_sprites[OIL_DRUM_SPRITE]        := $00_42_80_6f
    rend_sprites[OIL_DRUM_FLAME_SPRITE]  := $00_3C_81_5f
    game_state := GAME_LEVEL_3

PRI InitLevel4 | i
    ' Rivets
    SelectMap(LEVEL4_MAP)
    kong_real_x := $80
    kong_real_y := $37
    rend_sprites[MARIO_SPRITE]           := $04_00_3c_d7
    game_state := GAME_LEVEL_4

PRI MarioLogic | current_height, platform_height, ladder_top, ladder_bottom, delta, mario
    if frame & SPRITE_INVISIBLE<<8
        'debugdec(string("WHO DA THUNK IT"),0)
        'repeat 10000
        return
    mario := @rend_sprites[MARIO_SPRITE]
    current_height := byte[mario][SPRITE_YPOS]
    platform_height := PlatformHeight(byte[mario][SPRITE_XPOS],current_height) 
    ladder_top := LadderTopHeight(byte[mario][SPRITE_XPOS],current_height)
    ladder_bottom := LadderBottomHeight(byte[mario][SPRITE_XPOS],current_height)
    'debughex(string("FRAME"),frame)
    'debughex(string("MARIO SPRITE"),rend_sprites[MARIO_SPRITE])
    'debugdec(string("MARIO STATE"),mario_state)
    'debugdec(string("MARIO STATE COUNT"),mario_state_count)
    'debugdec(@laddertoptext,ladder_top)
    'debugdec(@currentytext,current_height)
    'debugdec(@platformheighttext,platform_height)
    'repeat 2000
    ' decide on next state, and do any unique initialisations for that state
    if (mario_state=<MARIO_CLIMB_DOWN)
        'but only if we have user control
        if (gp & GP_A) and (mario_state==MARIO_WALK_LEFT)
            mario_state:=MARIO_JUMP_LEFT
            frame := $00d
            mario_state_count:=0
            
        elseif (gp & GP_A) and (mario_state==MARIO_WALK_RIGHT)
            mario_state:=MARIO_JUMP_RIGHT
            frame := $10d
            mario_state_count:=0
         
        elseif (gp & GP_A) and (mario_state==MARIO_FACING_LEFT)
            mario_state:=MARIO_JUMP_UP_FACING_LEFT
            frame := $00d
            mario_state_count:=0
         
        elseif (gp & GP_A) and (mario_state==MARIO_FACING_RIGHT)
            mario_state:=MARIO_JUMP_UP_FACING_RIGHT
            frame := $10d
            mario_state_count:=0
         
        elseif (gp & GP_LEFT) and (current_height==platform_height)
            rotate(@mario_state_count,1,0,12)
            if mario_state_count//3 <> 1
                byte[mario][SPRITE_XPOS]-=1
            frame := lookupz(mario_state_count: 0,0,0,2,2,2,0,0,0,1,1,1)              
            mario_state:=MARIO_WALK_LEFT
         
        elseif (gp & GP_RIGHT) and (current_height==platform_height)
            rotate(@mario_state_count,1,0,12)
            if mario_state_count//3 <> 2
                byte[mario][SPRITE_XPOS]+=1
            frame := lookupz(mario_state_count: 0,0,0,2,2,2,0,0,0,1,1,1) | SPRITE_MIRRORED<<8
            mario_state:=MARIO_WALK_RIGHT
         
        elseif (gp & GP_UP) and (ladder_top<current_height)
            if (mario_state<>MARIO_CLIMB_UP) and (mario_state<>MARIO_CLIMB_DOWN)
                mario_state_count:=0
            else
                mario_state_count+=1
            if mario_state_count//5==0
                byte[mario][SPRITE_YPOS]-=2
                byte[mario][SPRITE_YPOS]<#=platform_height
            mario_state:=MARIO_CLIMB_UP
                 
        elseif (gp & GP_DOWN) and (ladder_bottom>current_height)
            if (mario_state<>MARIO_CLIMB_UP) and (mario_state<>MARIO_CLIMB_DOWN)
                mario_state_count:=0
            else
                mario_state_count-=1
            if mario_state_count//5==0
                byte[mario][SPRITE_YPOS]+=2
            mario_state:=MARIO_CLIMB_DOWN
         
        elseif (mario_state==MARIO_WALK_LEFT)
            mario_state:=MARIO_FACING_LEFT
         
        elseif (mario_state==MARIO_WALK_RIGHT)
            mario_state:=MARIO_FACING_RIGHT
    'DebugDec(@errortext,mario_state)
         
    'do the things that are common between states and that are done every game loop for a state
    if (mario_state==MARIO_CLIMB_DOWN) and (current_height==ladder_bottom-1)
        ' catch mario just before he goes below platform if he's on odd height.
        byte[mario][SPRITE_YPOS]:=ladder_bottom
        current_height:=ladder_bottom
    case mario_state
        MARIO_CLIMB_UP,MARIO_CLIMB_DOWN :
            case(ladder_bottom-current_height)/2
                0..1 : frame := 6
                other:
                    delta := (current_height-ladder_top)/2
                    'debugdec(string("DELTA"),delta)
                    'repeat 10000
                    case delta
                        -1000..-1: frame:=6 'negative number might happen with movable ladders?
                        0 : frame := 6
                        1 : frame := 3
                        2..3 : frame := 5
                        4..5 : frame := $104
                        other : frame := (delta//2)*$100+3
            byte[mario][SPRITE_XPOS]&=$F8
            byte[mario][SPRITE_XPOS]+=4
            if current_height==platform_height
                mario_state:=MARIO_FACING_LEFT                              'but, frame is facing away
                case game_state
                    GAME_LEVEL_1, GAME_LEVEL_2:
                        if current_height==23
                            game_level++
                            game_state := GAME_HOW_HIGH_INIT                        'go to next level
                    GAME_LEVEL_3:
                        if current_height==55
                            game_level++
                            game_state := GAME_HOW_HIGH_INIT                        'go to next level                    
                
        MARIO_WALK_LEFT, MARIO_WALK_RIGHT, MARIO_FACING_LEFT, MARIO_FACING_RIGHT:
            'deal with walking on platforms, inclines, lifts and falling   
            byte[mario][SPRITE_YPOS] := PlatformHeight(byte[mario][SPRITE_XPOS],byte[mario][SPRITE_YPOS])
             
        MARIO_JUMP_LEFT:
            'we lookup the y delta for each frame.  By offsetting by one, we ensure that overflow means one will be subtracted.
            byte[mario][SPRITE_YPOS]-=lookupz(mario_state_count: 3,2,2,2,2,2,2,2,1,2,2,1,2,1,2,1,1,1,2,1,1,1,0,1,1,1,0,1,0,1,0,0,1)-1
            if mario_state_count//2==0
                byte[mario][SPRITE_XPOS]-=1                 
            mario_state_count+=1
     
        MARIO_JUMP_RIGHT:
            'we lookup the y delta for each frame.  By offsetting by one, we ensure that overflow means one will be subtracted.
            byte[mario][SPRITE_YPOS]-=lookupz(mario_state_count: 3,2,2,2,2,2,2,2,1,2,2,1,2,1,2,1,1,1,2,1,1,1,0,1,1,1,0,1,0,1,0,0,1)-1
            if mario_state_count//2==0
                byte[mario][SPRITE_XPOS]+=1                 
            mario_state_count+=1
     
        MARIO_JUMP_UP_FACING_LEFT:
            'we lookup the y delta for each frame.  By offsetting by one, we ensure that overflow means one will be subtracted.
            byte[mario][SPRITE_YPOS]-=lookupz(mario_state_count: 3,2,2,2,2,2,2,2,1,2,2,1,2,1,2,1,1,1,2,1,1,1,0,1,1,1,0,1,0,1,0,0,1)-1
            mario_state_count+=1
     
        MARIO_JUMP_UP_FACING_RIGHT:
            'we lookup the y delta for each frame.  By offsetting by one, we ensure that overflow means one will be subtracted.
            byte[mario][SPRITE_YPOS]-=lookupz(mario_state_count: 3,2,2,2,2,2,2,2,1,2,2,1,2,1,2,1,1,1,2,1,1,1,0,1,1,1,0,1,0,1,0,0,1)-1
            mario_state_count+=1
     
        MARIO_LANDING_LEFT:
            'deal with lifts  
            byte[mario][SPRITE_YPOS] := PlatformHeight(byte[mario][SPRITE_XPOS],byte[mario][SPRITE_YPOS])
            if mario_state_count==4
                mario_state:=MARIO_FACING_LEFT
                frame := $000
            else
                mario_state_count++
     
        MARIO_LANDING_RIGHT:
            'deal with lifts  
            byte[mario][SPRITE_YPOS] := PlatformHeight(byte[mario][SPRITE_XPOS],byte[mario][SPRITE_YPOS])
            if mario_state_count==4
                mario_state:=MARIO_FACING_RIGHT
                frame := $100
            else
                mario_state_count++
     
    'catch jump states that have past completion 
    case mario_state
        MARIO_JUMP_LEFT,MARIO_JUMP_UP_FACING_LEFT:
            if current_height>platform_height and mario_state_count>3 'At least 32 frames into the jump to avoid latching on platforms above
                mario_state:=MARIO_LANDING_LEFT
                frame:=$00e
                mario_state_count:=0
                byte[mario][SPRITE_YPOS]:=platform_height
            elseif byte[mario][SPRITE_XPOS]<24
                mario_state:=MARIO_JUMP_RIGHT
                frame := $10d
                
        MARIO_JUMP_RIGHT,MARIO_JUMP_UP_FACING_RIGHT:
            if current_height>platform_height and mario_state_count>3 'At least 32 frames into the jump to avoid latching on platforms above 
                mario_state:=MARIO_LANDING_RIGHT
                frame:=$10e
                mario_state_count:=0
                byte[mario][SPRITE_YPOS]:=platform_height
            elseif byte[mario][SPRITE_XPOS]>234
                mario_state:=MARIO_JUMP_LEFT
                frame := $00d
     
    byte[mario][SPRITE_XPOS]#>=24        
    byte[mario][SPRITE_XPOS]<#=234
    word[mario][SPRITE_FLAGS_AND_TILE_WORD]:=frame

PRI KongLogic | i
    'debugdec(@kongstatetext,kong_state)
    kong_state_count++
    case kong_state
        KONG_LEVEL_START_POSE_INIT:
            kong_barrel_releases:=0
            kong_state_count := 0
            kong_pose_source:=@kong_center_sad_template
            SetKongSprites
            kong_state := KONG_LEVEL_START_POSE
        
        KONG_LEVEL_START_POSE:
            if kong_state_count == 64
                mario_state:=MARIO_WALK_RIGHT
                mario_state_count := 0
                'debugdec(string("MARIO STARTED"),0)
                frame := SPRITE_MIRRORED<<8
                if game_level//4
                    kong_state := KONG_NORMAL_INIT
                else
                    kong_state := KONG_BR_LEFT_INIT

        KONG_BR_LEFT_INIT:
            ' see if there's a barrel available.
            kong_holding_barrel := -1
            i := 0
            repeat while i<NUMBER_OF_BARRELS and kong_holding_barrel==-1
                if rend_sprites[MOVING_BARREL_SPRITES+i] & (SPRITE_INVISIBLE<<24)
                    kong_holding_barrel := i
                i++
            if kong_holding_barrel => 0
                barrel_state[kong_holding_barrel] := BARREL_STILL
                kong_state_count := 0
                kong_pose_source := @kong_left_template
                SetKongSprites
                kong_state := KONG_BR_LEFT
            'else stay in this state
                 
        KONG_BR_CENTER_1_INIT:
            ' keep barrel type
            'debugdec(@knongbarrelreleasestext,kong_barrel_releases)
            'repeat 1000000
                if kong_barrel_releases&$7 == 0
                    rend_sprites[MOVING_BARREL_SPRITES+kong_holding_barrel] := $00_19_3c_32
                else
                    rend_sprites[MOVING_BARREL_SPRITES+kong_holding_barrel] := $00_15_3c_32
            if kong_barrel_releases==0
                barrel_state[kong_holding_barrel] := BARREL_FALLING_DOWN
                kong_barrel_releases++                 
                kong_state := KONG_BR_CENTER_2_INIT
            else
                kong_state := KONG_BR_CENTER_1
            kong_state_count := 0
            kong_pose_source := @kong_center_barrel_template
            SetKongSprites
  
        KONG_BR_RIGHT_INIT:
            ' keep barrel type
            rend_sprites[MOVING_BARREL_SPRITES+kong_holding_barrel] -= $00_01_1E_00
            ' and add on x delta
            rend_sprites[MOVING_BARREL_SPRITES+kong_holding_barrel] += $00_00_3C_00
            kong_state_count := 0
            kong_pose_source := @kong_right_template
            SetKongSprites
            kong_state := KONG_BR_RIGHT

        KONG_BR_CENTER_2_INIT:
            'debugdec(@kongbarreltext, kong_holding_barrel)
            kong_state_count := 0
            kong_pose_source := @kong_center_sad_template
            SetKongSprites
            kong_state := KONG_BR_CENTER_2

        KONG_BR_GROWL_INIT:
            kong_state_count := 0
            kong_pose_source := @kong_center_roar_r_template
            SetKongSprites
            kong_state := KONG_BR_GROWL

        KONG_BR_LEFT:
            'debugdec(@kongstatecounttext,kong_state_count)
            if kong_state_count == 24
                kong_state := KONG_BR_CENTER_1_INIT

        KONG_BR_CENTER_1:
            if kong_state_count == 24
                kong_state := KONG_BR_RIGHT_INIT
                    
        KONG_BR_RIGHT:
            if kong_state_count == 24
                kong_state := KONG_BR_CENTER_2_INIT
                barrel_state[kong_holding_barrel]:=BARREL_ROLLING_RIGHT
                kong_holding_barrel := -3
                kong_barrel_releases++

        KONG_BR_CENTER_2:
            rnd := ?rnd
            if (rnd & $0000003F)==0
                kong_state := KONG_BR_GROWL_INIT
            elseif kong_state_count == 24
                kong_state := KONG_BR_LEFT_INIT

        KONG_BR_GROWL:
            if kong_state_count>24
                rnd := ?rnd
                if (rnd&$0000001F)==0  
                    kong_state := KONG_BR_LEFT_INIT

        KONG_NORMAL_INIT:
            kong_state_count:=0
            kong_pose_source := @kong_center_roar_r_template
            SetKongSprites
            kong_state := KONG_NORMAL
            
        KONG_NORMAL:
            case kong_state_count
                32,96:
                    kong_pose_source := @kong_center_roar_l_template
                    SetKongSprites
                64:
                    kong_pose_source := @kong_center_roar_r_template
                    SetKongSprites
                128:
                    kong_pose_source := @kong_center_sad_template
                    SetKongSprites
                256:
                    kong_state := KONG_NORMAL_INIT

PRI BarrelLogic | i, this_barrel, platform_height, height_to_fall, anim, mario
    mario := @rend_sprites[MARIO_SPRITE]
    repeat i from 0 to constant(NUMBER_OF_BARRELS-1)
        'debugdec(@barrelstatetext,barrel_state[i])
        this_barrel := @rend_sprites[MOVING_BARREL_SPRITES+i]

        'check for barrel dissapearing into oil drum
        if byte[this_barrel][SPRITE_XPOS]==$28 and byte[this_barrel][SPRITE_YPOS]>200 and barrel_state[i]<>BARREL_STILL and barrel_state[i]<FIREBALL_JUMP_RIGHT_INIT
            if byte[this_barrel][SPRITE_TILE]==$18 and drum_state<>DRUM_FLARING
                drum_state := DRUM_FLARING_INIT
                barrel_state[i]:=FIREBALL_WAITING
                barrel_state_count[i]:=62
            else
                byte[this_barrel][SPRITE_FLAGS]:=SPRITE_INVISIBLE
                barrel_state[i]:=BARREL_STILL            
        case barrel_state[i]
            BARREL_ROLLING_RIGHT:
                platform_height := PlatformHeight(byte[this_barrel][SPRITE_XPOS],byte[this_barrel][SPRITE_YPOS])
                if platform_height-(byte[this_barrel][SPRITE_YPOS]) > 3
                    barrel_state_count[i]:=0
                    barrel_state[i] := BARREL_FALLING_RIGHT
                else 
                    byte[this_barrel][SPRITE_XPOS]+=1
                    byte[this_barrel][SPRITE_YPOS]:=platform_height
                if byte[this_barrel][SPRITE_XPOS]&$07==4
                    'check for ladders only when centred over tiles
                    if BarrelLadderBottomHeight(byte[this_barrel][SPRITE_XPOS],byte[this_barrel][SPRITE_YPOS])>platform_height
                        rnd:=?rnd
                        'go down ladder randomly or brown barrel below mario 
                        if rnd//2 == 0 or (byte[this_barrel][SPRITE_TILE]<>$18 and byte[this_barrel][SPRITE_YPOS]>PlatformHeight(byte[mario][SPRITE_XPOS],byte[mario][SPRITE_YPOS]))
                            byte[this_barrel][SPRITE_YPOS]++
                            byte[this_barrel][SPRITE_TILE]++
                            barrel_state[i] := BARREL_ON_LADDER_RIGHT
                rotate(@barrel_anim[i],1,0,31)
            BARREL_ROLLING_LEFT:
                platform_height := PlatformHeight(byte[this_barrel][SPRITE_XPOS],byte[this_barrel][SPRITE_YPOS])
                if platform_height-(byte[this_barrel][SPRITE_YPOS]) > 3
                    barrel_state_count[i]:=0
                    barrel_state[i] := BARREL_FALLING_LEFT
                else 
                    byte[this_barrel][SPRITE_XPOS]-=1
                    byte[this_barrel][SPRITE_YPOS]:=platform_height
                if byte[this_barrel][SPRITE_XPOS]&$07==4
                    'check for ladders only when centred over tiles
                    if BarrelLadderBottomHeight(byte[this_barrel][SPRITE_XPOS],byte[this_barrel][SPRITE_YPOS])>platform_height
                        rnd:=?rnd
                        'go down ladder randomly or brown barrel below mario 
                        if rnd//2 == 0 or (byte[this_barrel][SPRITE_TILE]<>$18 and byte[this_barrel][SPRITE_YPOS]>PlatformHeight(byte[mario][SPRITE_XPOS],byte[mario][SPRITE_YPOS]))
                            byte[this_barrel][SPRITE_YPOS]++
                            byte[this_barrel][SPRITE_TILE]++
                            barrel_state[i] := BARREL_ON_LADDER_LEFT
                rotate(@barrel_anim[i],-1,0,31)
            BARREL_FALLING_RIGHT:
                platform_height := PlatformHeight(byte[this_barrel][SPRITE_XPOS],byte[this_barrel][SPRITE_YPOS])
                height_to_fall := platform_height-(byte[this_barrel][SPRITE_YPOS])
                'debugdec(@heighttofalltext,height_to_fall)
                if height_to_fall < 0
                    barrel_state_count[i]:=0
                    barrel_state[i] := BARREL_BOUNCING_LEFT    
                else
                    ' offset by 2 so that any additional falls will be 2
                    byte[this_barrel][SPRITE_YPOS]+=lookupz(barrel_state_count[i]: {-1,}-2,-2,-2,-2,-2,-2,-2,-2,-2,-1,-2,-2,-1,-1,-2,-1,-1,-1,-1,-2,0,-1,-1,-1,-1,0,-1,-1,0,-1)+2
                    byte[this_barrel][SPRITE_XPOS]+=lookupz(barrel_state_count[i]: { 1,} 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 1, 0, 1, 0, 0, 1, 0,0, 1, 0, 1, 0,0, 1, 0,0, 1)
                    barrel_state_count[i]++
                rotate(@barrel_anim[i],1,0,31)
            BARREL_FALLING_LEFT:
                platform_height := PlatformHeight(byte[this_barrel][SPRITE_XPOS],byte[this_barrel][SPRITE_YPOS])
                height_to_fall := platform_height-(byte[this_barrel][SPRITE_YPOS])
                'debugdec(@heighttofalltext,height_to_fall)
                if height_to_fall < 0
                    barrel_state_count[i]:=0
                    barrel_state[i] := BARREL_BOUNCING_RIGHT    
                else
                    ' offset by 2 so that any additional falls will be 2
                    byte[this_barrel][SPRITE_YPOS]+=lookupz(barrel_state_count[i]: {-1,}-2,-2,-2,-2,-2,-2,-2,-2,-2,-1,-2,-2,-1,-1,-2,-1,-1,-1,-1,-2,0,-1,-1,-1,-1,0,-1,-1,0,-1)+2
                    byte[this_barrel][SPRITE_XPOS]-=lookupz(barrel_state_count[i]: { 1,} 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 1, 0, 1, 0, 0, 1, 0,0, 1, 0, 1, 0,0, 1, 0,0, 1)
                    barrel_state_count[i]++
                rotate(@barrel_anim[i],-1,0,31)
            BARREL_BOUNCING_RIGHT:
                if barrel_state_count[i] =< 22
                    byte[this_barrel][SPRITE_YPOS]-=lookupz(barrel_state_count[i]: 1,0,0,1,0,0,0,0,0,-1,0,0,-1,0,0,-1,0,1,0,0,0,0,-1)
                    barrel_state_count[i]++                 
                    byte[this_barrel][SPRITE_XPOS]+=1
                else
                    barrel_state[i]:=BARREL_ROLLING_RIGHT
                rotate(@barrel_anim[i],1,0,31)
            BARREL_BOUNCING_LEFT:
                if barrel_state_count[i] =< 22
                    byte[this_barrel][SPRITE_YPOS]-=lookupz(barrel_state_count[i]: 1,0,0,1,0,0,0,0,0,-1,0,0,-1,0,0,-1,0,1,0,0,0,0,-1)
                    barrel_state_count[i]++                 
                    byte[this_barrel][SPRITE_XPOS]-=1
                else
                    barrel_state[i]:=BARREL_ROLLING_LEFT
                rotate(@barrel_anim[i],-1,0,31)
            BARREL_ON_LADDER_RIGHT:
                if (byte[this_barrel][SPRITE_YPOS]) < BarrelLadderBottomHeight(byte[this_barrel][SPRITE_XPOS],byte[this_barrel][SPRITE_YPOS])
                    byte[this_barrel][SPRITE_YPOS]++    
                else
                    byte[this_barrel][SPRITE_TILE]--
                    barrel_state[i] := BARREL_ROLLING_LEFT    
            BARREL_ON_LADDER_LEFT:
                if (byte[this_barrel][SPRITE_YPOS]) < BarrelLadderBottomHeight(byte[this_barrel][SPRITE_XPOS],byte[this_barrel][SPRITE_YPOS])
                    byte[this_barrel][SPRITE_YPOS]++    
                else
                    byte[this_barrel][SPRITE_TILE]--
                    barrel_state[i] := BARREL_ROLLING_RIGHT
            BARREL_FALLING_DOWN:
                platform_height := PlatformHeight(byte[this_barrel][SPRITE_XPOS],byte[this_barrel][SPRITE_YPOS])
                height_to_fall := platform_height-(byte[this_barrel][SPRITE_YPOS])
                'debugdec(@heighttofalltext,height_to_fall)
                if height_to_fall>0 and height_to_fall<2 and barrel_state_count[i]>10
                    barrel_state_count[i]:=0
                    if platform_height>200
                        byte[this_barrel][SPRITE_YPOS]-=1
                        byte[this_barrel][SPRITE_TILE] := $18
                        barrel_state[i]:=BARREL_BOUNCING_LEFT
                else
                    ' offset by 2 so that any additional falls will be 2
                    byte[this_barrel][SPRITE_YPOS]+=lookupz(barrel_state_count[i]: -2,-2,-2,-2,-2,-2,-1,-2,-1,-2,-1,-2,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,0,-1,0,-1,0,-1)+2
                    barrel_state_count[i]++
            FIREBALL_WAITING:
                if barrel_state_count[i]-- == 0
                    fireball_real_y[i]:=byte[this_barrel][SPRITE_YPOS]
                    barrel_state[i]:=FIREBALL_JUMP_RIGHT_INIT
            FIREBALL_JUMP_RIGHT_INIT:
                'debugdec(@fireballtext,i)
                'repeat  500000
                rend_sprites[MOVING_BARREL_SPRITES+i] := $00_39_28_d1
                fireball_real_y[i]:=$d1
                barrel_state_count[i]:=0
                barrel_state[i] := FIREBALL_JUMP_RIGHT
            FIREBALL_JUMP_RIGHT:
                if barrel_state_count[i]//2 == 0
                    fireball_real_y[i]+=lookupz(barrel_state_count[i]>>1: -2,-2,-2,-1,-1,-1,-1,-1,-1,0,-1,0,0,0,0,0,1,0,1,1,1,1,1,1,1,1,2,2,2,2,2)
                    byte[this_barrel][SPRITE_XPOS]++
                if barrel_state_count[i]++ ==62
                    barrel_state[i] := FIREBALL_BOUNCE_RIGHT_INIT
            FIREBALL_BOUNCE_LEFT_INIT:
                rnd := ?rnd
                if rnd//4
                    barrel_state[i]:=FIREBALL_BOUNCE_LEFT
                else
                    barrel_state[i]:=FIREBALL_BOUNCE_RIGHT
                barrel_state_count[i]:=0
            FIREBALL_BOUNCE_RIGHT_INIT:
                rnd := ?rnd
                if rnd//4
                    barrel_state[i]:=FIREBALL_BOUNCE_RIGHT
                else
                    barrel_state[i]:=FIREBALL_BOUNCE_LEFT
                barrel_state_count[i]:=0
            FIREBALL_BOUNCE_LEFT:
                platform_height := PlatformHeight(byte[this_barrel][SPRITE_XPOS],fireball_real_y[i])
                anim:=barrel_state_count[i]++ //16
                if anim==0
                    word[this_barrel][SPRITE_FLAGS_AND_TILE_WORD]:=$03a
                elseif anim==8
                    word[this_barrel][SPRITE_FLAGS_AND_TILE_WORD]:=$039
                if anim//2 
                    byte[this_barrel][SPRITE_XPOS]--
                    if platform_height-fireball_real_y[i]>3
                        byte[this_barrel][SPRITE_XPOS]++
                        barrel_state[i] := FIREBALL_BOUNCE_RIGHT
                    else
                        fireball_real_y[i]:=platform_height
                if barrel_state_count[i]==35
                    barrel_state[i]:=FIREBALL_BOUNCE_LEFT_INIT
                if byte[this_barrel][SPRITE_XPOS]&$07==4
                    'check for ladders only when centred over tiles
                    if BarrelLadderBottomHeight(byte[this_barrel][SPRITE_XPOS],fireball_real_y[i])>platform_height
                        rnd:=?rnd
                        if rnd//3 == 0
                            barrel_state_count[i]:=0
                            barrel_state[i] := FIREBALL_DOWN_LADDER
                   if LadderTopHeight(byte[this_barrel][SPRITE_XPOS],fireball_real_y[i])<platform_height
                        rnd:=?rnd
                        if rnd//3 == 0
                            barrel_state_count[i]:=0
                            barrel_state[i] := FIREBALL_UP_LADDER
            FIREBALL_BOUNCE_RIGHT:
                platform_height := PlatformHeight(byte[this_barrel][SPRITE_XPOS],fireball_real_y[i])
                'debugdec(@fireballtext,LadderBottomHeight(byte[this_fireball][SPRITE_XPOS],fireball_real_y[i]))
                'debugdec(@fireballtext,platform_height)
                'repeat 1000
                anim:=barrel_state_count[i]++ //16
                if anim==0
                    word[this_barrel][SPRITE_FLAGS_AND_TILE_WORD]:=$13a
                elseif anim==8
                    word[this_barrel][SPRITE_FLAGS_AND_TILE_WORD]:=$139
                if anim//2
                    byte[this_barrel][SPRITE_XPOS]++
                    platform_height := PlatformHeight(byte[this_barrel][SPRITE_XPOS],fireball_real_y[i])
                    if platform_height-fireball_real_y[i]>3
                        byte[this_barrel][SPRITE_XPOS]--
                        barrel_state[i] := FIREBALL_BOUNCE_LEFT
                    else
                        fireball_real_y[i]:=platform_height
                if barrel_state_count[i]==35
                    barrel_state[i]:=FIREBALL_BOUNCE_RIGHT_INIT
                if byte[this_barrel][SPRITE_XPOS]&$07==4
                    'check for ladders only when centred over tiles
                    'debugdec(string("CURRENTY"),fireball_real_y[i])
                    'debugdec(string("BARRELLADBOTTOM"),BarrelLadderBottomHeight(byte[this_barrel][SPRITE_XPOS],fireball_real_y[i]))
                    'repeat 1000000
                    if BarrelLadderBottomHeight(byte[this_barrel][SPRITE_XPOS],fireball_real_y[i])>platform_height
                        rnd:=?rnd
                        if rnd//3 == 0
                            barrel_state_count[i]:=0
                            barrel_state[i] := FIREBALL_DOWN_LADDER
                    if LadderTopHeight(byte[this_barrel][SPRITE_XPOS],fireball_real_y[i])<platform_height
                        rnd:=?rnd
                        if rnd//3 == 0
                            barrel_state_count[i]:=0
                            barrel_state[i] := FIREBALL_UP_LADDER
            FIREBALL_UP_LADDER:
                anim:=barrel_state_count[i]++ //16
                if anim==0
                    byte[this_barrel][SPRITE_TILE]:=$3a
                elseif anim==8
                    byte[this_barrel][SPRITE_TILE]:=$39
                if barrel_state_count[i]>35
                    barrel_state_count[i]:=0    
                if barrel_state_count[i] //4 ==0
                    platform_height := PlatformHeight(byte[this_barrel][SPRITE_XPOS],fireball_real_y[i])
                    if fireball_real_y[i] == platform_height
                        barrel_state[i]:=FIREBALL_BOUNCE_LEFT_INIT
                    fireball_real_y[i]--
            FIREBALL_DOWN_LADDER:
                anim:=barrel_state_count[i]-- //16
                if anim==0
                    byte[this_barrel][SPRITE_TILE]:=$3a
                elseif anim==8
                    byte[this_barrel][SPRITE_TILE]:=$39
                if barrel_state_count[i]<0
                    barrel_state_count[i]:=35    
                if barrel_state_count[i] //4 ==0
                    platform_height := PlatformHeight(byte[this_barrel][SPRITE_XPOS],fireball_real_y[i])
                    'debugdec(@currentheighttext,fireball_real_y[i])
                    'debugdec(@platformheighttext,platform_height)
                    if fireball_real_y[i] == platform_height
                        barrel_state[i]:=FIREBALL_BOUNCE_RIGHT_INIT
                        'debugdec(@currentheighttext,fireball_real_y[i])
                        'debugdec(@platformheighttext,platform_height)
                    fireball_real_y[i]++

        case barrel_state[i]
            BARREL_ROLLING_RIGHT,BARREL_ROLLING_LEFT,BARREL_FALLING_RIGHT,BARREL_FALLING_LEFT,BARREL_BOUNCING_RIGHT,BARREL_BOUNCING_LEFT:
                byte[this_barrel][SPRITE_FLAGS]:=lookupz(barrel_anim[i]>>3:%00,%10,%11,%01)    
                'debugdec(@barrelanimtext,byte[this_barrel][SPRITE_FLAGS])
            FIREBALL_JUMP_RIGHT_INIT,FIREBALL_JUMP_RIGHT,FIREBALL_BOUNCE_LEFT_INIT,FIREBALL_BOUNCE_RIGHT_INIT,FIREBALL_BOUNCE_LEFT,FIREBALL_BOUNCE_RIGHT,FIREBALL_MOVE_RIGHT,FIREBALL_UP_LADDER,FIREBALL_DOWN_LADDER,FIREBALL_WAITING:
                byte[this_barrel][SPRITE_YPOS] := fireball_real_y[i] - lookupz(barrel_state_count[i]/2: 0,1,1,2,2,2,2,2,2,2,2,2,2,1,1,0,1,0)
                                            
PRI DrumLogic | found,i
    case drum_state
        DRUM_FLARING_INIT:
            drum_state_count:=62
            rnd := ?rnd
            drum_flicker_count:=rnd&$b + 4
            rend_sprites[OIL_DRUM_FLAME_SPRITE] := $00_3D_28_c8
            drum_state := DRUM_FLARING
        DRUM_FLARING:
            if drum_flicker_count-- == 0
                rend_sprites[OIL_DRUM_FLAME_SPRITE] ^= $00_03_00_00 'swap between $3d and 3E
                rnd := ?rnd
                drum_flicker_count:=rnd&$b + 4
            'debugdec(@barrelstatetext,drum_state_count)
            if drum_state_count-- == 0
                drum_state := DRUM_LIT_INIT
        DRUM_LIT_INIT:
            rnd := ?rnd
            drum_flicker_count:=rnd&$b + 4
            rend_sprites[OIL_DRUM_FLAME_SPRITE] := $00_3C_29_c8
            drum_state := DRUM_LIT
        DRUM_LIT:
            if drum_flicker_count-- == 0
                rend_sprites[OIL_DRUM_FLAME_SPRITE] ^= $00_07_00_00 'swap between $3b and 3c
                rnd := ?rnd
                drum_flicker_count:=rnd&$b + 4

PRI PaulineLogic
    case pauline_state
        PAULINE_STILL_INIT:
            case game_state
                GAME_LEVEL_1..GAME_LEVEL_3:
                    rend_sprites[PAULINE_SPRITES]   := $00_0f_70_17
                    rend_sprites[PAULINE_SPRITES+1] := $00_10_70_17
                    word[rend_map][15] := 32
                    word[rend_map][16] := 32
                    word[rend_map][17] := 32
                GAME_LEVEL_4:
                    rend_sprites[PAULINE_SPRITES]   := $00_0f_60_17
                    rend_sprites[PAULINE_SPRITES+1] := $00_10_60_17
                    word[rend_map][13] := 32
                    word[rend_map][14] := 32
                    word[rend_map][15] := 32
            pauline_state := PAULINE_STILL
            pauline_state_count := 192
        PAULINE_STILL:
            pauline_state_count--
            if pauline_state_count == 0
                pauline_state := PAULINE_SCREAM_INIT
        PAULINE_SCREAM_INIT:
            case game_state
                GAME_LEVEL_1..GAME_LEVEL_3:
                    rend_sprites[PAULINE_SPRITES]   := $00_0f_70_17
                    rend_sprites[PAULINE_SPRITES+1] := $00_10_70_17
                    word[rend_map][15] := 132
                    word[rend_map][16] := 133
                    word[rend_map][17] := 134
                GAME_LEVEL_4:
                    rend_sprites[PAULINE_SPRITES]   := $00_0f_60_17
                    rend_sprites[PAULINE_SPRITES+1] := $00_10_60_17
                    word[rend_map][13] := 132
                    word[rend_map][14] := 133
                    word[rend_map][15] := 134                
            pauline_state := PAULINE_SCREAM
            pauline_state_count := 64
        PAULINE_SCREAM:
            pauline_state_count--
            if pauline_state_count//8 == 0
                rend_sprites[PAULINE_SPRITES+1] ^= $00_01_00_00
            if pauline_state_count == 0
                pauline_state := PAULINE_STILL_INIT

PRI LiftLogic | i, mario, mario_x, mario_y, distance
    mario := @rend_sprites[MARIO_SPRITE]
    if lift_state_count-- == 0
        lift_state_count := 1
        repeat i from LIFT_SPRITES to constant(LIFT_SPRITES+2)
            byte[@rend_sprites[i]][SPRITE_YPOS]--
            if byte[@rend_sprites[i]][SPRITE_YPOS]<58
                byte[@rend_sprites[i]][SPRITE_YPOS]+=$9c
        repeat i from constant(LIFT_SPRITES+3) to constant(LIFT_SPRITES+5)
            byte[@rend_sprites[i]][SPRITE_YPOS]++
            if byte[@rend_sprites[i]][SPRITE_YPOS]>58+$9c
                byte[@rend_sprites[i]][SPRITE_YPOS]-=$9c

PRI SpringLogic | i
    'There are 25 elements in the bounce YPOS lookup.  Each is matched by 2 added to XPOS = 50 per bounce.
    'So 4 bounces gets across the screen to where we drop.  Drop is 3 pixels per frame.
    repeat i from 0 to constant(NUMBER_OF_SPRINGS-1)
        case spring_state_count[i]
            0..99: 
                byte[@rend_sprites[SPRING_SPRITES+i]][SPRITE_YPOS]+=lookupz(spring_state_count[i]//25: -3,-3,-3,-2,-2,-2,-2,-1,-1,0,-1,0,0,1,0,1,1,2,2,2,2,3,3,3,0)
                spring_real_x[i]+=2
            100..198:
                byte[@rend_sprites[SPRING_SPRITES+i]][SPRITE_YPOS]+=2
            199:
                spring_state_count[i] := -1
                rnd := ?rnd
                spring_real_x[i] := -7 + rnd&$F
                byte[@rend_sprites[SPRING_SPRITES+i]][SPRITE_YPOS]:=$37
        if spring_real_x[i]=>8
            byte[@rend_sprites[SPRING_SPRITES+i]][SPRITE_XPOS] := spring_real_x[i]
            'if (spring_state_count[i]+5)//25<10
            if spring_state_count[i]//32<16
                word[@rend_sprites[SPRING_SPRITES+i]][SPRITE_FLAGS_AND_TILE_WORD]:=$38
            else
                word[@rend_sprites[SPRING_SPRITES+i]][SPRITE_FLAGS_AND_TILE_WORD]:=$37
        else
                word[@rend_sprites[SPRING_SPRITES+i]][SPRITE_FLAGS_AND_TILE_WORD]:=constant(SPRITE_INVISIBLE<<8)                        
        spring_state_count[i]++

PRI Ladderlogic | i
    repeat i from 0 to constant(NUMBER_OF_LADDERS-1)
        case ladder_state[i]
            LADDER_UP:
                case ladder_state_count[i]++
                    0:  SetTile(4+23*i, 8, 168)
                    255:
                        if i==0
                            ladder_state_count[i] := 0
                            ladder_state[i] := LADDER_GOING_DOWN
                    273:
                        if i==1
                            ladder_state_count[i] := 0
                            ladder_state[i] := LADDER_GOING_DOWN
            LADDER_GOING_DOWN:
                case ladder_state_count[i]++
                    0:  SetTile(4+23*i, 8, 32)
                    63: SetTile(4+23*i, 9, 32)
                    127:
                        ladder_state_count[i] := 0
                        ladder_state[i] := LADDER_DOWN
                if ladder_state_count[i]//8==0
                    byte[@rend_sprites[LADDER_SPRITES+i]][SPRITE_YPOS]++
            LADDER_DOWN:
                case ladder_state_count[i]++
                    15:
                        ladder_state_count[i] := 0
                        ladder_state[i] := LADDER_GOING_UP            
            LADDER_GOING_UP:
                case ladder_state_count[i]++
                    31: SetTile(4+23*i, 9, 168)
                    63:
                        ladder_state_count[i] := 0
                        ladder_state[i] := LADDER_UP
                if ladder_state_count[i]//4==0
                    byte[@rend_sprites[LADDER_SPRITES+i]][SPRITE_YPOS]--

PRI ConveyorLogic | pie_available, i
    'move existing pies
    if conveyor_state_count++//2==0
        repeat i from 0 to constant(NUMBER_OF_PIES-1)
            if not byte[@rend_sprites[PIE_SPRITES+i]][SPRITE_FLAGS]&SPRITE_INVISIBLE
                if byte[@rend_sprites[PIE_SPRITES+i]][SPRITE_YPOS]==$af
                    'it's on the bottom conveyor
                    case bottom_conveyor_state
                        CONVEYOR_RIGHT:
                            byte[@rend_sprites[PIE_SPRITES+i]][SPRITE_XPOS]++
                            if byte[@rend_sprites[PIE_SPRITES+i]][SPRITE_XPOS]==$F1
                                byte[@rend_sprites[PIE_SPRITES+i]][SPRITE_FLAGS]:=SPRITE_INVISIBLE    
                        CONVEYOR_LEFT:
                            byte[@rend_sprites[PIE_SPRITES+i]][SPRITE_XPOS]--
                            if byte[@rend_sprites[PIE_SPRITES+i]][SPRITE_XPOS]==$0F
                                byte[@rend_sprites[PIE_SPRITES+i]][SPRITE_FLAGS]:=SPRITE_INVISIBLE
                elseif byte[@rend_sprites[PIE_SPRITES+i]][SPRITE_XPOS]<$80
                    'it's on the middle left conveyor
                    case middle_left_conveyor_state
                        CONVEYOR_RIGHT:
                            byte[@rend_sprites[PIE_SPRITES+i]][SPRITE_XPOS]++
                            if byte[@rend_sprites[PIE_SPRITES+i]][SPRITE_XPOS]==$80
                                byte[@rend_sprites[PIE_SPRITES+i]][SPRITE_FLAGS]:=SPRITE_INVISIBLE    
                        CONVEYOR_LEFT:
                            byte[@rend_sprites[PIE_SPRITES+i]][SPRITE_XPOS]--
                            if byte[@rend_sprites[PIE_SPRITES+i]][SPRITE_XPOS]==$0F
                                byte[@rend_sprites[PIE_SPRITES+i]][SPRITE_FLAGS]:=SPRITE_INVISIBLE
                else
                    'it's on the middle right conveyor
                     case middle_right_conveyor_state
                        CONVEYOR_RIGHT:
                            byte[@rend_sprites[PIE_SPRITES+i]][SPRITE_XPOS]++
                            if byte[@rend_sprites[PIE_SPRITES+i]][SPRITE_XPOS]==$F1
                                byte[@rend_sprites[PIE_SPRITES+i]][SPRITE_FLAGS]:=SPRITE_INVISIBLE    
                        CONVEYOR_LEFT:
                            byte[@rend_sprites[PIE_SPRITES+i]][SPRITE_XPOS]--
                            if byte[@rend_sprites[PIE_SPRITES+i]][SPRITE_XPOS]==$80
                                byte[@rend_sprites[PIE_SPRITES+i]][SPRITE_FLAGS]:=SPRITE_INVISIBLE
        'move mario
        if byte[@rend_sprites[MARIO_SPRITE]][SPRITE_YPOS]==$af
            'Mario's on the bottom conveyor
            case bottom_conveyor_state
                CONVEYOR_RIGHT:
                    byte[@rend_sprites[MARIO_SPRITE]][SPRITE_XPOS]++
                CONVEYOR_LEFT:
                    byte[@rend_sprites[MARIO_SPRITE]][SPRITE_XPOS]--
        elseif byte[@rend_sprites[MARIO_SPRITE]][SPRITE_YPOS]==$5f
            if byte[@rend_sprites[MARIO_SPRITE]][SPRITE_XPOS]<$80
                'Mario's on the middle left conveyor
                case middle_left_conveyor_state
                    CONVEYOR_RIGHT:
                        byte[@rend_sprites[MARIO_SPRITE]][SPRITE_XPOS]++
                    CONVEYOR_LEFT:
                        byte[@rend_sprites[MARIO_SPRITE]][SPRITE_XPOS]--
            else
                'Mario's on the middle right conveyor
                 case middle_right_conveyor_state
                    CONVEYOR_RIGHT:
                        byte[@rend_sprites[MARIO_SPRITE]][SPRITE_XPOS]++
                    CONVEYOR_LEFT:
                        byte[@rend_sprites[MARIO_SPRITE]][SPRITE_XPOS]--
                     

    'move kong and change direction of conveyors                
    case kong_conveyor_state
        CONVEYOR_RIGHT:
            if kong_conveyor_state_count//2==0
                kong_real_x++
                SetKongSprites
            kong_conveyor_state_count++
            if kong_conveyor_state_count==128
                middle_left_conveyor_state ^= 1
            if kong_conveyor_state_count==256
                kong_conveyor_state:=CONVEYOR_LEFT
        CONVEYOR_LEFT:
            if kong_conveyor_state_count//2==0
                kong_real_x--
                SetKongSprites
            kong_conveyor_state_count--
            if kong_conveyor_state_count==0
                kong_conveyor_state:=CONVEYOR_RIGHT
                bottom_conveyor_state ^= 1
            if kong_conveyor_state_count==128
                middle_right_conveyor_state ^= 1
    'create pies
    if pie_state_count++ == 125
        pie_available := -1
        repeat i from 0 to constant(NUMBER_OF_PIES-1)
            if byte[@rend_sprites[PIE_SPRITES+i]][SPRITE_FLAGS]&SPRITE_INVISIBLE
                pie_available := i
                quit
        if pie_available=>0
            repeat
                rnd := ?rnd
                case rnd&$3
                    0:
                        if middle_left_conveyor_state==CONVEYOR_RIGHT
                            rend_sprites[PIE_SPRITES+i] := $00_43_10_5f
                            quit    
                    1:
                        if middle_right_conveyor_state==CONVEYOR_LEFT
                            rend_sprites[PIE_SPRITES+i] := $00_43_F0_5f
                            quit       
                    2:
                        if bottom_conveyor_state==CONVEYOR_RIGHT
                            rend_sprites[PIE_SPRITES+i] := $00_43_10_af
                            quit         
                    3:
                        if bottom_conveyor_state==CONVEYOR_LEFT
                            rend_sprites[PIE_SPRITES+i] := $00_43_F0_af
                            quit  
        pie_state_count := 0
        

PRI Rotate(item_ptr,increment,lower,upper)
    ' Rotate a byte value through a range of values.  Useful for sprite animation.
    ' byte_item = pointer to a variable to ,reset,lower,upper)
    ' increment = value to add or subtract
    ' lower     = lower bound
    ' upper     = upper bound
    ' if the value is out of range, this doesn't try to apply limits if moving towards the loop.
    long[item_ptr]+=increment
    if increment>0
        if long[item_ptr]>upper
            long[item_ptr] := lower
    else
        if long[item_ptr]<lower
            long[item_ptr] := upper
    return

PRI TileAt(px,py) | pos
    if py>223
        if py>231
            return 159               ' An empty space to avoid it looking like there is a ladder going down
        return 32                  ' A full platform so that platfor_height always returns a value 
    pos := (px>>3+(py>>3)*32)<<1
    return byte[rend_map][pos]
    
PRI SetTile(tx,ty,tile) | pos
    pos := (tx+ty*32)<<1
    byte[rend_map][pos] := tile
    
PRI TileHeight(tile)    
    if (tile=>143 and tile=<144)
        return tile-143
    if (tile=>159 and tile=<166)
        return tile-159
    return 0

PRI PlatformHeight(_x,_y) | background, i, distance
    ' Calculates the position of one pixel above height of the platform where we are.
    ' If we are stood on the platform it's where our feet are.
    ' If our feet are overlapping a platform it's the top of that.(To cope with inclines.)
    ' Otherwise it's the first platform below.
    if game_state == GAME_LEVEL_2
        if _x=>$30 and _x<$40
            repeat i from LIFT_SPRITES to constant(LIFT_SPRITES+2)
                distance := _y-byte[@rend_sprites[i]][SPRITE_YPOS]
                case distance
                    -3..3: return byte[@rend_sprites[i]][SPRITE_YPOS]
        if _x=>$70 and _x<$80
            repeat i from constant(LIFT_SPRITES+3) to constant(LIFT_SPRITES+5)
                distance := _y-byte[@rend_sprites[i]][SPRITE_YPOS]
                case distance
                    -3..3: return byte[@rend_sprites[i]][SPRITE_YPOS]
    repeat
        background := TileAt(_x,_y)
        case background
            'top of platform
            143..150:       return (_y & $F8)+(background-144)      
            159..166:       return (_y & $F8)+(background-160)
            'empty space, we need to look below
            32:             _y+=8                                        'empty space
            'full platforms
            35,36,115:          return (_y & $F8)-1
            'lower platform - lots of it
            142:            return (_y & $F8)+(background-144)           'tile with ladder below
            158:            return (_y & $F8)+(background-144)           'platform with space below
            'lower platform - not much
            135..141:       _y+=8                                        'tile with ladder below
            152..157:       _y+=8                                        'platform with space below
            other:          _y+=8

PRI LadderTopHeight(_x,_y) | background, current_y
    ' Calculates the position of the platform at the top of a ladder.  
    ' If we are by a ladder, then this one pixel above the platform at the top of the ladder,
    ' Otherwise it's the same value as PlatformHeight( ).
    ' If it's a broken ladder, then it's still the position of the platform above.
    current_y := PlatformHeight(_x,_y)
    repeat
        if current_y<0
            ' This must be one of Kong's ladders
            return _y
        background := TileAt(_x,current_y)
'        debugdec(@tiletext,background)
        case background
            135..150,168:   current_y-=8                                         'ladders + workaround invisible ladder
            'top of platform
            159..166:       return (current_y & $F8)+(background-160)
            'empty space
            32:             return current_y                          'empty space
            'full platforms
            35,36:          current_y-=8
            'lower platform - lots of it
            158:            return (current_y & $F8)+(background-144)           'platform with space below
            'lower platform - not much
            152..157:       return current_y                          'platform with space below
            other:          return current_y

PRI LadderBottomHeight(_x,_y) | background
    ' Calculates the position of the platform at the bottom of a ladder.  
    ' If we are above a ladder, then this one pixel above the platform at the bottom of the ladder,
    ' Otherwise it's the same value as PlatformHeight( ).
    ' If it's a broken ladder, then that doesn't count.  It's still the position of the platform above.
    _y := PlatformHeight(_x,_y)
    background := TileAt(_x,_y+8)
    if (background==143 or background==159 or background==35 or background==36) and TileAt(_x,_y+16)<>32
        _y+=8
    repeat
        background := TileAt(_x,_y+8)
        'debugdec(@tiletext,background)
        case background
            'empty space
            32:             return _y-8                          'empty space
            'full platforms
            35,36:          return (_y & $F8)+7
            135..150,168:   _y+=8                                        'ladders + workaround invisible ladder
            152..158:       return (_y & $F8)+(background-152)           'platform with space below
            other:          return (_y & $F8)+7

PRI BarrelLadderBottomHeight(_x,_y) | background
    ' Calculates the position of the platform at the bottom of a ladder.  
    ' If we are above a ladder, then this one pixel above the platform at the bottom of the ladder,
    ' Otherwise it's the same value as LowPlatformHeight( ).
    ' If it's a broken ladder, then that doesn't count.  It's still the position of the platform above.
    ' This is a varioation for barrels, which will include ladders with gaps. 
    'debugdec(string("YBEFORE"),_y)
    _y := PlatformHeight(_x,_y)
    'debugdec(string("YAFTER"),_y)
    background := TileAt(_x,_y+8)
    if (background==143 or background==159) and TileAt(_x,_y+16)<>32
        _y+=8
        'debugdec(string("EXTRA"),0)
    repeat
        background := TileAt(_x,_y+8)
        'debugdec(@tiletext,background)
        case background
            'full platforms
            35,36,143,159:          return (_y & $F8)+7
            135..150,168:   _y+=8                           'ladders + workaround invisible ladder
            152..158:       return (_y & $F8)+(background-152) 'platform with space below
            other:          return (_y & $F8)+7

{PRI IsLadder(tile)
    if (tile=>135) and (tile=<150)
        return TRUE
    return FALSE
    
PRI IsEndOfLadder(tile)
    if (tile=>159) and (tile=<166)
        return TRUE
    return FALSE
}
PRI SelectMap(map)
    rend_map := gfx.map_adr+constant(32*28*2)*map

PRI PrintString(_x,_y,text,palette) | pos, i
    pos := _x+_y*32
    repeat i from 0 to strsize(text)-1
        word[rend_map][pos++] := byte[text][i] + palette<<8

PRI PrintKong(x,y) | char, palette, xx, yy, pos
    char := 91
    palette := 5<<8
    repeat yy from y to y+3
        pos := x+yy*32
        repeat xx from x to x+5
            word[rend_map][pos++] := char++ +palette

PRI PrintKongHeight(x,y,h) | palette, pos
    palette := 5<<8
    pos := x+y*32
    word[rend_map][pos++] := lookupz(h:2,5,7,1) +palette
    word[rend_map][pos++] := lookupz(h:5,0,5,0) +palette
    word[rend_map][pos++] := lookupz(h:32,32,32,0) +palette
    word[rend_map][pos] := 126 +palette

PRI SetKongSprites | dest, i, temp, end, block
    block := kong_pose_source 
    dest := @rend_sprites[kong_sprites]
    if game_state==GAME_LEVEL_1
        '8 sprites in centre barrel pose
        end := 7
    else
        'reusing 2 kong sprites on level 3 for ladders
        end := 5
    repeat i from 0 to end
        temp:=long[block]
        byte[@temp] := kong_real_y
        'debugdec(string("KONGX"),kong_real_x)
        repeat 1000
        byte[@temp][1] += kong_real_x - $3c  
        long[dest]:=temp
        block+=4
        dest+=4
                      
CON
' //////////////////////////////////////////////////////////////////
' NES Game Paddle Read
' //////////////////////////////////////////////////////////////////       
' reads both gamepads in parallel encodes 8-bits for each in format
' right game pad #1 [15..8] : left game pad #0 [7..0]

    GP_RIGHT  = %00000001
    GP_LEFT   = %00000010
    GP_DOWN   = %00000100
    GP_UP     = %00001000
    GP_START  = %00010000
    GP_SELECT = %00100000
    GP_B      = %01000000
    GP_A      = %10000000

PUB NES_Read_Gamepad : nes_bits        |  i

' set I/O ports to proper direction
' P3 = JOY_CLK      (4)
' P4 = JOY_SH/LDn   (5) 
' P5 = JOY_DATAOUT0 (6)
' P6 = JOY_DATAOUT1 (7)
' NES Bit Encoding

' step 1: set I/Os
DIRA [3] := 1 ' output
DIRA [4] := 1 ' output
DIRA [5] := 0 ' input
DIRA [6] := 0 ' input

' step 2: set clock and latch to 0
OUTA [3] := 0 ' JOY_CLK = 0
OUTA [4] := 0 ' JOY_SH/LDn = 0
'Delay(1)

' step 3: set latch to 1
OUTA [4] := 1 ' JOY_SH/LDn = 1
'Delay(1)

' step 4: set latch to 0
OUTA [4] := 0 ' JOY_SH/LDn = 0

' step 5: read first bit of each game pad

' data is now ready to shift out
' first bit is ready 
nes_bits := 0

' left controller
nes_bits := INA[5] | (INA[6] << 8)

' step 7: read next 7 bits
repeat i from 0 to 6
 OUTA [3] := 1 ' JOY_CLK = 1
 'Delay(1)             
 OUTA [3] := 0 ' JOY_CLK = 0
 nes_bits := (nes_bits << 1)
 nes_bits := nes_bits | INA[5] | (INA[6] << 8)

 'Delay(1)             
' invert bits to make positive logic
nes_bits := (!nes_bits & $FFFF)

' //////////////////////////////////////////////////////////////////
' End NES Game Paddle Read
' //////////////////////////////////////////////////////////////////  

VAR
  long  row
  long  col

DAT

laddertoptext           byte    "LADDERTOP",0
ladderbottomtext        byte    "LADDERBOTTOM",0
tiletext                byte    "TILE",0
platformheighttext      byte    "PLATFORMHEIGHT",0
deltatext               byte    "DELTATEXT",0
currentheighttext       byte    "CURRENTHEIGHT",0
ypostext                byte    "YPOS",0
errortext               byte    "ERROR",0
kongstatetext           byte    "KONGSTATE",0
kongstatecounttext      byte    "KONGSTATECOUNT",0
barrelstatetext         byte    "BARRELSTATE",0
kongbarreltext          byte    "KONGHOLDINGBARREL",0
heighttofalltext        byte    "HEIGHTTOFALL",0
knongbarrelreleasestext byte    "KONGBARRELRELEASES",0
timetext                byte    "TIME",0
barrelanimtext          byte    "BARRELANIM",0
fireballtext            byte    "FIREBALL",0
currentytext            byte    "CURRENTY",0

PUB DebugInit(map)
    wordfill(map,32,32*28)
    DebugReset

PUB DebugReset
  row := 10
  col := 0

{PUB DebugHex(title,number) | i, digit
    i:=0
    repeat while byte[title][i]<>0
        debug_map[row*32+col++] := byte[title][i]
        i++
    debug_map[row*32+col++] := 58
    digit := (number >> 28)
    debug_map[row*32+col++] := digit+48-(digit>9)*7
    digit := ((number >> 24) & $F)
    debug_map[row*32+col++] := digit+48-(digit>9)*7
    digit := ((number >> 20) & $F)
    debug_map[row*32+col++] := digit+48-(digit>9)*7
    digit := ((number >> 16) & $F)
    debug_map[row*32+col++] := digit+48-(digit>9)*7
    digit := ((number >> 12) & $F)
    debug_map[row*32+col++] := digit+48-(digit>9)*7
    digit := ((number >> 8) & $F)
    debug_map[row*32+col++] := digit+48-(digit>9)*7
    digit := ((number >> 4) & $F)
    debug_map[row*32+col++] := digit+48-(digit>9)*7
    digit := (number & $F)
    debug_map[row*32+col++] := digit+48-(digit>9)*7 
    col:=0
    row+=1
    row<#=27
}
PUB DebugDec(title,number) | i
    i:=0
    repeat while byte[title][i]<>0
        debug_map[row*32+col++] := byte[title][i]
        i++
    debug_map[row*32+col++] := 58
    debug_map[row*32+col+9] := number//10 + 48
    number/=10   
    debug_map[row*32+col+8] := number//10 + 48
    number/=10   
    debug_map[row*32+col+7] := number//10 + 48
    number/=10   
    debug_map[row*32+col+6] := number//10 + 48
    number/=10   
    debug_map[row*32+col+5] := number//10 + 48
    number/=10   
    debug_map[row*32+col+4] := number//10 + 48
    number/=10   
    debug_map[row*32+col+3] := number//10 + 48
    number/=10            
    debug_map[row*32+col+2] := number//10 + 48
    number/=10   
    debug_map[row*32+col+1] := number//10 + 48
    number/=10   
    debug_map[row*32+col+0] := number//10 + 48
    col:=0
    row+=1
    row<#=27
  
DAT
'For some reason the first DAT long is corrupted even before Main is run. 
                        long    0
'Used for Kong doing barrel rolling
kong_center_barrel_template
                        long    $00_22_3c_00            'torso
                        long    $01_20_3c_00            'head
                        long    $00_24_48_00            'right leg
                        long    $01_24_30_00            'left leg
                        long    $01_28_2c_00            'left arm
                        long    $00_28_4c_00            'right arm
                        long    $01_27_2c_00            'left shoulder
                        long    $00_27_4c_00            'right shoulder
kong_center_sad_template
                        long    $00_22_3c_00            'torso
                        long    $01_20_3c_00            'head
                        long    $00_24_48_00            'right leg
                        long    $01_24_30_00            'left leg
                        long    $00_26_31_00            'left arm
                        long    $01_26_47_00            'right arm
                        long    $04_00_00_00            'empty
                        long    $04_00_00_00            'empty
kong_left_template
                        long    $00_2b_3a_00            'torso
                        long    $00_2d_2a_00            'head
                        long    $00_29_4a_00            'right leg
                        long    $00_2a_2a_00            'left leg
                        long    $00_2c_3a_00            'shoulder
                        long    $04_00_00_00            'empty
                        long    $04_00_00_00            'empty
                        long    $04_00_00_00            'empty
kong_right_template
                        long    $01_2b_3c_00            'torso
                        long    $01_2d_4c_00            'head
                        long    $01_29_2c_00            'right leg
                        long    $01_2a_4c_00            'left leg
                        long    $01_2c_3c_00            'shoulder
                        long    $04_00_00_00            'empty
                        long    $04_00_00_00            'empty
                        long    $04_00_00_00            'empty

' Used for normal kong state Levels 2-4
kong_center_roar_r_template
                        long    $00_22_3c_00            'torso
                        long    $01_21_3c_00            'head
                        long    $00_24_48_00            'right leg
                        long    $00_23_30_00            'left leg
                        long    $00_26_31_00            'left arm
                        long    $00_25_4c_00            'right arm
                        long    $04_00_00_00            'empty
                        long    $04_00_00_00            'empty
kong_center_roar_l_template
                        long    $00_22_3c_00            'torso
                        long    $01_21_3c_00            'head
                        long    $01_23_48_00            'right leg
                        long    $01_24_30_00            'left leg
                        long    $01_25_2c_00            'left arm
                        long    $01_26_47_00            'right arm
                        long    $04_00_00_00            'empty
                        long    $04_00_00_00            'empty

DAT

' Hub scanline buffer = 256 pixels, 8 bits per pixel = 2048 bits = 256 bytes = 64 longs
hub_scanline_buffer
colorbar0               long    $0b_0b_0b_0b
colorbar1               long    $0c_0c_0c_0c
colorbar2               long    $0d_0d_0d_0d
colorbar3               long    $0e_0e_0e_0e
colorbar4               long    $1b_0b_1b_1b
colorbar5               long    $1c_0c_1c_1c
colorbar6               long    $1d_0d_1d_1d
colorbar7               long    $1e_0e_1e_1e
colorbar8               long    $2b_0b_2b_2b
colorbar9               long    $2c_2c_2c_2c
colorbar10              long    $2d_2d_2d_2d
colorbar11              long    $2e_2e_2e_2e
colorbar12              long    $3b_3b_3b_3b
colorbar13              long    $3c_3c_3c_3c
colorbar14              long    $3d_3d_3d_3d
colorbar15              long    $3e_3e_3e_3e
colorbar16              long    $4b_4b_4b_4b
colorbar17              long    $4c_4c_4c_4c
colorbar18              long    $4d_4d_4d_4d
colorbar19              long    $4e_4e_4e_4e
colorbar20              long    $5b_5b_5b_5b
colorbar21              long    $5c_5c_5c_5c
colorbar22              long    $5d_5d_5d_5d
colorbar23              long    $5e_5e_5e_5e
colorbar24              long    $6b_6b_6b_6b
colorbar25              long    $6c_6c_6c_6c
colorbar26              long    $6d_6d_6d_6d
colorbar27              long    $6e_6e_6e_6e
colorbar28              long    $7b_7b_7b_7b
colorbar29              long    $7c_7c_7c_7c
colorbar30              long    $7d_7d_7d_7d
colorbar31              long    $7e_7e_7e_7e
colorbar32              long    $8b_8b_8b_8b
colorbar33              long    $8c_8c_8c_8c
colorbar34              long    $8d_8d_8d_8d
colorbar35              long    $8e_8e_8e_8e
colorbar36              long    $9b_9b_9b_9b
colorbar37              long    $9c_9c_9c_9c
colorbar38              long    $9d_9d_9d_9d
colorbar39              long    $9e_9e_9e_9e
colorbar40              long    $ab_ab_ab_ab
colorbar41              long    $ac_ac_ac_ac
colorbar42              long    $ad_ad_ad_ad
colorbar43              long    $ae_ae_ae_ae
colorbar44              long    $bb_bb_bb_bb
colorbar45              long    $bc_bc_bc_bc
colorbar46              long    $bd_bd_bd_bd
colorbar47              long    $be_be_be_be
colorbar48              long    $cb_cb_cb_cb
colorbar49              long    $cc_cc_cc_cc
colorbar50              long    $cd_cd_cd_cd
colorbar51              long    $ce_ce_ce_ce
colorbar52              long    $db_db_db_db
colorbar53              long    $dc_dc_dc_dc
colorbar54              long    $dd_dd_dd_dd
colorbar55              long    $de_de_de_de
colorbar56              long    $eb_eb_eb_eb
colorbar57              long    $ec_ec_ec_ec
colorbar58              long    $ed_ed_ed_ed
colorbar59              long    $ee_ee_ee_ee
colorbar60              long    $fb_fb_fb_fb
colorbar61              long    $fc_fc_fc_fc
colorbar62              long    $fd_fd_fd_fd
colorbar63              long    $fe_fe_fe_fe
' End of scanline buffer

scanline_req            long    0    